import java.awt.*;
import java.applet.*;
import java.lang.*;

public class log1 extends Applet{

  int left=25;
  int top=25;
  int dfXNum=16;
  int dfYNum=11;
  int[][][] df=new int[dfXNum][dfYNum][4];
  double[][] solutions=new double[301][201];
  int[] displayFlags=new int[301];
  Button clearButton=new Button("Clear");
  Image offI;
  Graphics f;
  Dimension d,offD;
  int[] phasePortrait=new int[121];


  public void init(){
    int j,m;
    double r=4.0;
    double k=1.5;
    double p=0.0;
    double rka=0;
    double rkb=0;
    double rkc=0;
    double rkd=0;
    double h=2.0/200.0;
    double slope=0.0;
    double deltaT;

    setLayout(null);
    add(clearButton);
    
    for(j=0;j<=300;j++){
      displayFlags[j]=0;}

    for(j=0;j<=300;j++){
      solutions[j][0]=2.0-(double)j/100.0;
      for(m=1;m<=200;m++){
	p=solutions[j][m-1];
	rka=h*r*(1-p/k)*p;
	p=p+.5*rka;
	rkb=h*r*(1-p/k)*p; 
	p=p-.5*rka+.5*rkb;
	rkc=h*r*(1-p/k)*p;
	p=p-.5*rkb+rkc;
	rkd=h*r*(1-p/k)*p;
	solutions[j][m]=solutions[j][m-1]+(1.0/6.0)*(rka+2*rkb+2*rkc+rkd);
      }
    }

    for(j=0;j<=120;j++){
      p=-1.0+3.0*(double)j/120.0;
      phasePortrait[j]=(int)(70.0-(35.0)*r*(1-p/k)*p);
    }

    for(j=0;j<dfXNum;j++){
      for(m=0;m<dfYNum;m++){
	df[j][m][0]=left+25*j;}}

    for(j=0;j<dfXNum;j++){
      for(m=0;m<dfYNum;m++){
	df[j][m][1]=top+25*m+12;}}
    
    for(j=0;j<dfXNum;j++){
      for(m=0;m<dfYNum;m++){
	p=2.0+(top-df[j][m][1])/100.0;
	slope=r*p*(1-p/k);
	deltaT=Math.sqrt(.15*.15/(1+slope*slope));
	if(deltaT>=.075){deltaT=.075;}
	df[j][m][2]=(int)Math.floor(deltaT*200.0)+df[j][m][0];
	df[j][m][3]=-1*(int)Math.floor(slope*deltaT*100.0)+df[j][m][1];
      }
    }
  }

  public boolean mouseUp(Event e,int x,int y){
    Graphics newg=getGraphics();
    if(y>=top){
      if(y<=top+300){
	if(x>=left){
	  if(x<=left+400){
	    displayFlags[y-top]=1;
	  }
	}
      }
    }
    update(newg);
    return(true);
  }

  public boolean action(Event e,Object arg){
    Object target=e.target;
    int j;
    Graphics newg=getGraphics();

    if(target==clearButton){
      for(j=0;j<=300;j++){
	displayFlags[j]=0;}
      update(newg);
    }
    return(true);
  }

  public void paint(Graphics g){
    d=size();
    clearButton.reshape(left+420,top+275,60,25);
    update(g);
  }

  public void update(Graphics g){
    int j;
    int m;
    int drawFlag=1;

    if((f==null)                     // Setup an off-screen image
       ||(d.width !=offD.width)      // via the update() method.
       ||(d.height != offD.height))  //
      {
	offD=d;
	offI=createImage(d.width, d.height);
	f=offI.getGraphics();
      }

    f.setFont(new Font("Helvetica",Font.PLAIN,12));
    
    setBackground(Color.gray);
    f.setColor(getBackground());
    f.fillRect(0,0,d.width,d.height);
    f.setColor(Color.black);
    f.fillRect(left,top,400,301);
    
    f.setColor(Color.lightGray);
    
    for(j=0;j<dfXNum;j++){
      for(m=0;m<dfYNum;m++){
	f.drawLine(df[j][m][0],df[j][m][1],df[j][m][2],df[j][m][3]);

      }
    }

    f.setColor(Color.white);
    f.drawLine(left,top,left,top+300);
    f.drawLine(left,top+200,left+400,top+200);


 
    
    f.setColor(Color.green);
    for(j=0;j<=300;j++){
      if(displayFlags[j]==1){
	//	for(m=0;m<=399;m++){
	m=0;
	drawFlag=1;
	while(drawFlag==1){
	  if(m<=198){
	    if(solutions[j][m+2]<=-.999){
	      drawFlag=0;
	      f.drawLine(left+2*m+2,top+(int)Math.floor(200.0-100.0*solutions[j][m+1]),left+2*m+4,top+300);
	    }
	  }
	  if(m==199){drawFlag=0;}
	  f.drawLine(left+2*m,top+(int)Math.floor(200.0-100.0*solutions[j][m]),left+2*m+2,top+(int)Math.floor(200.0-100.0*solutions[j][m+1]));
	  m=m+1;
	}
      }
    }

    f.setColor(Color.black);
    f.fillRect(left+420,top+135,120,131);
    f.setColor(Color.white);
    f.drawLine(left+420,top+205,left+540,top+205);
    f.drawLine(left+460,top+135,left+460,top+265);
    f.drawString("P",left+530,top+201);
    f.drawString("P'",left+463,top+149);
    
    f.setColor(Color.yellow);
    for(j=0;j<=119;j++){
      if(phasePortrait[j]<=130){
        if(phasePortrait[j+1]<=130){
      f.drawLine(left+420+j,top+135+phasePortrait[j],left+420+j+1,top+135+phasePortrait[j+1]);
        }}
      if(phasePortrait[j]<=130){if(phasePortrait[j+1]>130){
        f.drawLine(left+420+j,top+135+phasePortrait[j],left+420+j+1,top+265);}}
      if(phasePortrait[j]>130){if(phasePortrait[j+1]<=130){
        f.drawLine(left+420+j,top+265,left+420+j+1,top+135+phasePortrait[j+1]);
      }}
    }
    f.setColor(Color.white);
    f.drawLine(left+520,top+202,left+520,top+208);
    f.setFont(new Font("Helvetica",Font.PLAIN,12));
    f.drawString("K",left+518,top+220);


    f.setColor(Color.white);
    for(j=0;j<=7;j++){
      f.drawLine(left+50+50*j,top+197,left+50+50*j,top+203);
      f.drawString(Double.toString((double)j*.25+.25),left+40+50*j,top+217);
    }
    f.drawString("0",left-11,top+205);
    f.setFont(new Font("Helvetica",Font.PLAIN,14));
    f.drawString("P",left+5,top+14);
    f.drawString("t",left+392,top+198);
    f.drawString("K",left-11,top+55);
    f.drawLine(left-3,top+50,left+3,top+50);


    g.drawImage(offI,0,0,this);
  }
}











